{****************************************************************************
 *           } Unit UNetWare;{ (c) 1999 Michal Cihar                        *
 ****************************************************************************
 This unit enables to use a few Novell Netware functions
 NOTE: some functions are optimalized for ussage on FELIS server on FEL CVUT
       and in any other Novell Netware network it is unfunctional, you should
       modify procedures GetCompNumber and GetComp and may be FindCompInfo
 Sample file LOCATION.SRC is now included so you can view what procedures
 FindCompInfo, GetComp and GetCompNumber are doing.}
interface
const UnitID='UNetWare';
      UnitCopyright='1999 Michal Cihar';
      UnitVersion='0.9';
      UnitRelease='30.3.1999';
type tDateTime=record
                   Year,
                   Month,
                   Day,
                   Hour,
                   Min,
                   Sec,
                   DOW: byte;
                  end;
const HexDigit:array[0..15] of char='0123456789ABCDEF'; {Convert to hex}
      DaysOfWeek : array [0..6] of String[9] =          {day names}
                   ('Sunday','Monday','Tuesday',
                    'Wednesday','Thursday','Friday',
                    'Saturday');
      {follows data about current connection/server, obtained on start:}
      MaxServerUsers:word=0;
      ServerDistributor:string='';
      ServerVersion:string='';
      ServerRelease:string='';
      ServerCopyright:string='';
      ServerName:string='';
      UserConnection:byte=0;
      UserName:string='';
      UserRealName:string='';
      UserIDHex:string='';
      UserCompS:string='';
      UserPlaceS:string='';
      UserCompInfo:string='';
      UserComp:word=0;
      UserPlace:word=0;
      UserSite:word=0;
      UserLoginTime:tDateTime=(
                   Year:0;
                   Month:0;
                   Day:0;
                   Hour:0;
                   Min:0;
                   Sec:0;
                   DOW:0);
      UserConnectionType:word=0;
      AddressServerNumber:string='';
      AddressStationNumber:string='';
      AddressSocketNumber:string='';
      {Follows object type constants:}
      ObjUnknown                   = 00;
      ObjUser                      = 01;
      ObjUserGroup                 = 02;
      ObjPrintQueue                = 03;
      ObjFileServer                = 04;
      ObjJobServer                 = 05;
      ObjGateway                   = 06;
      ObjPrintServer               = 07;
      ObjArchiveQueue              = 08;
      ObjArchiveServer             = 09;
      ObjJobQueue                  = $0a;
      ObjAdministration            = $0b;
      ObjNAS_SNAGateway            = $21;
      ObjRemoteBridgeServer_       = $24;
      ObjRemoteBridgeServer        = $26;
      ObjTCPIPGateway              = $27;
      ObjTimeSynchronizationServer = $2d;
      ObjArchiveServerDynamicSAP   = $2e;
      ObjAdvertisingPrintServer    = $47;
      ObjPrintQueueUwer            = $53;
      ObjAny                       = $ffff;
      {Site information:
       NOTE: this is made only for FEL CVUT in any other Novell Netware
             it is unfunctional, you should modify procedures GetCompNumber
             and GetComp and may be FindcompInfo}
      SiteUnknown                  = $00;
      SiteDejvice                  = $01;
      SiteZikova                   = $02;
      SiteHaly                     = $03;
      SiteNames:array[0..3] of string[12]=('Not known','Dejvice','Zikova','Haly Dejvice');


{station connection number}
function GetConnection:byte;

{station information}
function GetStationInfo(const Number:byte;var Name, IDHex:string;var LoginTime:tDateTime;var ConnectionType: word):byte;

{intergnet address ?}
function GetInternetAdress(const Number:byte;var ServerNumber, StationNumber, SocketNumber:string):byte;

{user real name}
function GetRealName(const UserName:string;var Name:string):byte;

{server information}
function GetServerInfo(var Distributor, Version, Release, Copyright, Name:string;var MaxUsers:word):byte;

{send message to station}
function SendMessageStation(const Station:byte;Message:string):byte;

{send personal message to station}
function PersonalMessageStation(const Station:byte;Message:string):byte;

{find user by user name}
function FindUser(UserName:string):byte;

{finds computer information in file LOCATION.SRT}
function FindCompInfo(id:string):string;

{gets computer number and place - string}
procedure GetComp(info:string;var comp,place:string);

{gets computer number, place and site as numbers}
procedure GetCompNumber(info:string;var comp,place,site:word);

{true if file exists}
function FileExists(FileName: String): Boolean;

implementation
uses dos;
type tInfoInBuf=record
                   LenBuf:word;
                   FuncNum:byte;
                   ConnectionNum:byte;
                  end;
     tInfoOutBuf=record
                   LenBuf:word;
                   IDNum:array[1..4] of byte;
                   ConnType:array[1..2] of byte;
                   ObjName:array[1..48] of char;
                   ObjLoginTime:tDateTime;
                  end;
     tRealNameInBuf=record
                   LenBuf:word;
                   FuncNum:byte;
                   ObjType:array[1..2] of byte;
                   ObjName:string[47];
                   Segment:byte;
                   PropName:string[14];
                  end;
     tRealNameOutBuf=record
                   LenBuf:word;
                   RealName:array[1..128] of char;
                   MoreSegments:byte;
                   PropFlags:byte;
                  end;
     tAddressInBuf=record
                   LenBuf:word;
                   FuncNum:byte;
                   ConnectionNum:byte;
                  end;
     tAddressOutBuf=record
                   LenBuf:word;
                   Network:array[1..4] of byte;
                   Node:array[1..6] of byte;
                   Socket:array[1..2] of byte;
                  end;
     tSeverInBuf=record
                   LenBuf:word;
                   FuncNum:byte;
                  end;
     tSever1OutBuf=record
                   LenBuf:word;
                   Info:array[1..512] of char;
                  end;
     tSever2OutBuf=record
                   LenBuf:word;
                   ServerName:array[1..48] of char;
                   NetVer,
                   NetSubVer:byte;
                   MaxUser:word;
                   Info:array[1..75] of char;
                  end;
     tMessage1InBuf=record
                   LenBuf:word;
                   FuncNum:byte;
                   Count:byte;
                   StationList:byte;
                   Msg:string[55];
                  end;
     tMessage2InBuf=record
                   LenBuf:word;
                   FuncNum:byte;
                   Count:byte;
                   StationList:byte;
                   Msg:string[126];
                  end;
     tMessageOutBuf=record
                   LenBuf:word;
                   Count:byte;
                   ResultList:byte;
                  end;
     tInBuf=record
                   LenBuf:word;
                   FuncNum:byte;
                   ConnectionNum:byte;
                  end;
     tOutBuf=record
                   LenBuf:word;
                   IDNum:array[1..4] of byte;
                   ConnType:array[1..2] of byte;
                   ObjName:array[1..48] of char;
                   ObjLoginTime:tDateTime;
                  end;

function GetConnection; assembler;
asm
mov ah, 0dch
int 21h
end; {GetConnection}

function GetStationInfo;
var InBuf:tInfoInBuf;
    OutBuf:tInfoOutBuf;
    r:registers;
    Result:byte;
    i:byte;
begin;
with InBuf do
begin;
   LenBuf:=2;
   FuncNum:=$16;
   ConnectionNum:=Number;
end;
with OutBuf do
begin;
   LenBuf:=62;
end;
with r do
begin;
   ah:=$e3;
   ds:=seg(InBuf);
   si:=ofs(InBuf);
   es:=seg(OutBuf);
   di:=ofs(OutBuf);
end;
MSDos(r);
Result:=r.al;
if Result=0 then
begin;
   Name:='';
   with OutBuf do
   begin;
      i:=1;
      while (ObjName[i]<>#0)and(i<=48) do
      begin;
         Name:=Name+ObjName[i];
         inc(i);
      end;
      LoginTime:=ObjLoginTime;
      ConnectionType:=ConnType[2]+(ConnType[1] shl 8);
      IDHex:=      HexDigit[OutBuf.IDNum[1] shr 4];
      IDHex:=IDHex+HexDigit[OutBuf.IDNum[1] and $0f];
      IDHex:=IDHex+HexDigit[OutBuf.IDNum[2] shr 4];
      IDHex:=IDHex+HexDigit[OutBuf.IDNum[2] and $0f];
      IDHex:=IDHex+HexDigit[OutBuf.IDNum[3] shr 4];
      IDHex:=IDHex+HexDigit[OutBuf.IDNum[3] and $0f];
      IDHex:=IDHex+HexDigit[OutBuf.IDNum[4] shr 4];
      IDHex:=IDHex+HexDigit[OutBuf.IDNum[4] and $0f];
   end;
end;
GetStationInfo:=Result;
end; {GetStationInfo}

function GetRealName;
var InBuf:tRealNameInBuf;
    OutBuf:tRealNameOutBuf;
    r:registers;
    Result:byte;
    i:byte;
begin;
{const UserName:string;var RealName:string}
with InBuf do
begin;
   LenBuf:=69;
   FuncNum:=$3d;
   ObjType[1]:=0;
   ObjType[2]:=1;
   fillchar(ObjName,sizeof(objname),0);
   objname:=username;
   objname[0]:=#47;
   Segment:=1;
   PropName:='IDENTIFICATION';
   PropName[0]:=#14;
end;
with OutBuf do
begin;
   LenBuf:=130;
   FillChar(RealName,SizeOf(RealName),0);
   MoreSegments:=1;
   PropFlags:=0;
end;
with r do
begin;
   ah:=$e3;
   ds:=seg(InBuf);
   si:=ofs(InBuf);
   es:=seg(OutBuf);
   di:=ofs(OutBuf);
end;
MSDos(r);
Result:=r.al;
{if Result=0 then}
begin;
   i:=1;
   Name:='';
   while (OutBuf.RealName[i]<>#0)and(i<=128) do
   begin;
      Name:=Name+OutBuf.RealName[i];
      inc(i);
   end;
end;
GetRealName:=Result;
end; {GetRealName}

function GetServerInfo;
var InBuf:tSeverInBuf;
    OutBuf1:tSever1OutBuf;
    OutBuf2:tSever2OutBuf;
    r:registers;
    Result:byte;
    i:word;
begin;
with InBuf do
begin;
   LenBuf:=1;
   FuncNum:=$c9;
end;
with OutBuf1 do
begin;
   LenBuf:=512;
   FillChar(Info,SizeOf(Info),0);
end;
with r do
begin;
   ah:=$e3;
   ds:=seg(InBuf);
   si:=ofs(InBuf);
   es:=seg(OutBuf1);
   di:=ofs(OutBuf1);
end;
MSDos(r);
Result:=r.al;
if Result=0 then {?}
begin;
   Distributor:='';
   Version:='';
   Release:='';
   Copyright:='';
   i:=1;
   while (OutBuf1.Info[i]<>#0)and(i<=512) do
   begin;
      Distributor:=Distributor+OutBuf1.Info[i];
      inc(i);
   end;
      inc(i);
   while (OutBuf1.Info[i]<>#0)and(i<=512) do
   begin;
      Version:=Version+OutBuf1.Info[i];
      inc(i);
   end;
      inc(i);
   while (OutBuf1.Info[i]<>#0)and(i<=512) do
   begin;
      Release:=Release+OutBuf1.Info[i];
      inc(i);
   end;
      inc(i);
   while (OutBuf1.Info[i]<>#0)and(i<=512) do
   begin;
      Copyright:=Copyright+OutBuf1.Info[i];
      inc(i);
   end;
{name & maxusers}
with InBuf do
begin;
   LenBuf:=1;
   FuncNum:=17;
end;
with OutBuf2 do
begin;
   LenBuf:=128;
end;
with r do
begin;
   ah:=$e3;
   ds:=seg(InBuf);
   si:=ofs(InBuf);
   es:=seg(OutBuf2);
   di:=ofs(OutBuf2);
end;
MSDos(r);
Result:=r.al;
if Result=0 then {?}
with OutBuf2 do
begin;
   i:=0;
   MaxUsers:=MaxUser;
   Name:='';
   i:=1;
   while (OutBuf2.ServerName[i]<>#0)and(i<=48) do
   begin;
      Name:=Name+OutBuf2.ServerName[i];
      inc(i);
   end;
end;
end;
GetServerInfo:=Result;
end; {GetServerInfo}

function SendMessageStation;
var InBuf:tMessage2InBuf;
    OutBuf:tMessageOutBuf;
    r:registers;
begin;
if length(message)>55 then message:=copy(message,1,55);
with inbuf do
begin;
   lenbuf:=59;
   funcnum:=0;
   count:=1;
   stationlist:=station;
   Msg:=message+#0;
{   dec(msg[0]);}
end;
with outbuf do
begin;
   lenbuf:=2;
   count:=1;
   resultlist:=0;
end;
with r do
begin;
   ah:=$e1;
   ds:=seg(InBuf);
   si:=ofs(InBuf);
   es:=seg(OutBuf);
   di:=ofs(OutBuf);
end;
MSDos(r);
SendMessageStation:=outbuf.resultlist;
end; {SendMessageStation}

function PersonalMessageStation;
var InBuf:tMessage1InBuf;
    OutBuf:tMessageOutBuf;
    r:registers;
begin;
if length(message)>126 then message:=copy(message,1,126);
with inbuf do
begin;
   lenbuf:=130;
   funcnum:=4;
   count:=1;
   stationlist:=station;
   Msg:=message+#0;
{   dec(msg[0]);}
end;
with outbuf do
begin;
   lenbuf:=2;
   count:=1;
   resultlist:=0;
end;
with r do
begin;
   ah:=$e1;
   ds:=seg(InBuf);
   si:=ofs(InBuf);
   es:=seg(OutBuf);
   di:=ofs(OutBuf);
end;
MSDos(r);
PersonalMessageStation:=outbuf.resultlist;
end; {PersonalMessageStation}

function GetInternetAdress;
var InBuf:tAddressInBuf;
    OutBuf:tAddressOutBuf;
    r:registers;
    i:byte;
    Result:byte;
begin;
with inbuf do
begin;
   lenbuf:=2;
   funcnum:=$13;
   connectionnum:=number;
end;
fillchar(outbuf,sizeof(outbuf),0);
outbuf.lenbuf:=12;
with r do
begin;
   ah:=$e3;
   ds:=seg(InBuf);
   si:=ofs(InBuf);
   es:=seg(OutBuf);
   di:=ofs(OutBuf);
end;
MSDos(r);
Result:=r.al;
if Result=0 then {?}
begin;
   ServerNumber:='';
   StationNumber:='';
   SocketNumber:='';
   for i:=1 to 4 do
   begin;
      ServerNumber:=ServerNumber+HexDigit[OutBuf.Network[i] shr 4];
      ServerNumber:=ServerNumber+HexDigit[OutBuf.Network[i] and $0f];
   end;
   for i:=1 to 6 do
   begin;
      StationNumber:=StationNumber+HexDigit[OutBuf.Node[i] shr 4];
      StationNumber:=StationNumber+HexDigit[OutBuf.Node[i] and $0f];
   end;
   for i:=1 to 2 do
   begin;
      SocketNumber:=SocketNumber+HexDigit[OutBuf.Socket[i] shr 4];
      SocketNumber:=SocketNumber+HexDigit[OutBuf.Socket[i] and $0f];
   end;
end;
GetInternetAdress:=result;
end; {GetInternetAdress}

function FindUser;
var Number:word;
    Name, IDHex:string;
    LoginTime:tDateTime;
    ConnectionType: word;
begin;
   for Number:=1 to length(UserName) do UserName[Number]:=UpCase(UserName[Number]);
   for Number:=1 to 255{MaxServerUsers} do
   begin;
      if GetStationInfo(Number, Name, IDHex, LoginTime, ConnectionType)=0 then
           if Name=UserName then break;
   end;
if Name=UserName then FindUser:=Number else FindUser:=0;
end;

function FileExists;
var
 F: file;
begin
 {$I-}
 Assign(F, FileName);
 FileMode := 0;
 Reset(F);
 Close(F);
 {$I+}
 FileExists := (IOResult = 0) and (FileName <> '');
end;  { FileExists }


function findcompinfo;
var f:text;
    s1:string[12];
    s2:string;
begin;
id:=copy(id,1,12);
if fileexists('LOCATION.SRT') then assign(f,'LOCATION.SRT') else
if fileexists('F:\PUBLIC\BAT\LOCATION.SRT') then assign(f,'F:\PUBLIC\BAT\LOCATION.SRT') else
writeln('UNetWare ERROR: Can''t open datafile LOCATION.SRT');
reset(F);
s1:='';
while (s1<>id)and(not(eof(f))) do
begin;
read(f,s1);
readln(f,s2);
end;
while s2[1]=' ' do s2:=copy(s2,2,length(s2)-1);
if s1=id then findcompinfo:=s2
         else findcompinfo:='';
end;

function str2word(const s:string):word;
var code:integer;
    long:word;
begin;
val(s,long,code);
str2word:=long;
end;

procedure getcomp;
begin;
place:=copy(info,1,8);
while place[1]=' ' do place:=copy(place,2,length(place)-1);
while place[length(place)]=' ' do place:=copy(place,1,length(place)-1);
comp:=copy(info,17,length(info)-16);
while comp[1]=' ' do comp:=copy(comp,2,length(comp)-1);
while comp[length(comp)]=' ' do comp:=copy(comp,1,length(comp)-1);
end; {getcomp}

procedure getcompnumber;
var comp0,place0,places:string;
    i:byte;
begin;
getcomp(info,comp0,place0);
places:='';
i:=0;
if place0='' then places:='0' else
if upcase(place0[1]) in ['A'..'Z'] then
begin;
   if (upcase(place0[1])='Z')and(pos('/',place0)>0)and(pos('-',place0)=0) then
   begin;
      i:=2;
      while place0[i] in ['0'..'9'] do
            begin; places:=places+place0[i]; inc(i); end;
   end else
   if pos('-',place0)>0 then
   begin;
      i:=pos('-',place0)+1;
      while place0[i] in ['0'..'9'] do
            begin; places:=places+place0[i]; inc(i); end;
   end else
   if pos(' ',place0)>0 then
   begin;
      i:=pos(' ',place0)+1;
      while place0[i] in ['0'..'9'] do
            begin; places:=places+place0[i]; inc(i); end;
   end else
   if pos('_',place0)>0 then
   begin;
      i:=pos('_',place0)+1;
      while place0[i] in ['0'..'9'] do
            begin; places:=places+place0[i]; inc(i); end;
   end else
   if pos('.',place0)>0 then
   begin;
      i:=pos('.',place0)+1;
      while place0[i] in ['0'..'9'] do
            begin; places:=places+place0[i]; inc(i); end;
   end else
   if pos('/',place0)>0 then
   begin;
      i:=pos('/',place0)+1;
      while place0[i] in ['0'..'9'] do
            begin; places:=places+place0[i]; inc(i); end;
   end else
   begin;
      i:=2;
      while place0[i] in ['0'..'9'] do
            begin; places:=places+place0[i]; inc(i); end;
   end;
end else
begin;
   i:=1;
   while place0[i] in ['0'..'9'] do
         begin; places:=places+place0[i]; inc(i); end;
end;
place:=str2word(places);
case place of 115:if upcase(comp0[1])='U' then places:=copy(comp0,2,2) else places:='0';
              404:if upcase(comp0[1])='P' then
                  begin;
                     if length(comp0)=10 then places:=copy(comp0,2,2) else
                     if length(comp0)=9 then places:=copy(comp0,2,1) else
                        places:='0';
                  end else places:='0';
              else places:='0';
              end;
comp:=str2word(places);
case upcase(place0[1]) of 'Z':site:=SiteZikova;
                          'H':site:=SiteHaly;
                          'A','B','C','D':site:=SiteDejvice;
                          '0'..'9':site:=SiteDejvice;
                          else site:=SiteUnknown;
                          end;
end; {getcompnumber}


begin; {init}
writeln('UNetWare: retrieving NetWare information');
if GetServerInfo(ServerDistributor, ServerVersion, ServerRelease, ServerCopyright, ServerName, MaxServerUsers)<>0
   then writeln('UNetWare ERROR: No Novell NetWare server found');
UserConnection:=GetConnection;
if UserConnection=0
   then writeln('UNetWare ERROR: This computer is not logged in Novell NetWare')
else
begin;
if GetStationInfo(UserConnection,UserName, UserIDHex,UserLoginTime,UserConnectionType)<>0
   then writeln('UNetWare ERROR: Can''t investigate user info');
if GetInternetAdress(UserConnection,AddressServerNumber, AddressStationNumber, AddressSocketNumber) <>0
   then writeln('UNetWare ERROR: Can''t investigate internet adress');
if getrealname(UserName,UserRealName) <>0
   then writeln('UNetWare ERROR: Can''t investigate user real name');
UserCompInfo:=findcompinfo(AddressStationNumber);
getcomp(UserCompInfo,UserCompS,UserPlaceS);
getcompnumber(UserCompInfo,UserComp,UserPlace,UserSite);
end;
end.